<?php
// Copyright (C) <2015>  <it-novum GmbH>
//
// This file is dual licensed
//
// 1.
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, version 3 of the License.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// 2.
//  If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//  under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//  License agreement and license key will be shipped with the order
//  confirmation.

namespace WMIModule\Lib\InitialDatabase;

use itnovum\openITCOCKPIT\InitialDatabase\Importer;

/**
 * Class TemplateImport
 * @package WMIModule\Lib\InitialDatabase
 */
class TemplateImport extends Importer {
    public function __construct() {
        $TemplateImporter = new \App\itnovum\openITCOCKPIT\ImportTemplates\TemplateImport(
            \Cake\ORM\TableRegistry::getTableLocator()->get('Commands'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Macros'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Servicetemplates'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Hosttemplates'),
            \Cake\ORM\TableRegistry::getTableLocator()->get('Servicetemplategroups')
        );
        $TemplateImporter->import($this->getData());
    }

    public function getData() {
        return [
            'Commands'              => $this->getCommandsData(),
            'Macros'                => $this->getMacrosData(),
            'Hosttemplates'         => $this->getHosttemplatesData(),
            'Servicetemplates'      => $this->getServicetemplatesData(),
            'Servicetemplategroups' => $this->getServicetemplategroupsData()
        ];
    }

    /**
     * @return array
     */
    public function getCommandsData() {
        $data = [
            0 =>
                [
                    'name'             => 'check_wmi',
                    'command_line'     => '$USER1$/check_wmi_plus.pl -H $HOSTADDRESS$ -m $ARG1$ -u $USER2$ -p $USER3$  -t 60 $ARG2$',
                    'command_type'     => '1',
                    'human_args'       => null,
                    'uuid'             => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'description'      => 'Check Command for wmi plus',
                    'commandarguments' =>
                        [
                            0 =>
                                [
                                    'name'       => '$ARG1$',
                                    'human_name' => 'Modul',
                                ],
                            1 =>
                                [
                                    'name'       => '$ARG2$',
                                    'human_name' => 'Command Extension',
                                ],
                        ],
                ],
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getMacrosData() {
        $data = [
            0 =>
                [
                    'name'        => '$USER2$',
                    'value'       => 'A',
                    'description' => 'Windows WMI Plugin - Active Directory Username',
                    'password'    => '0',
                    'created'     => '2017-06-27 09:56:14',
                    'modified'    => '2017-07-21 15:06:32',
                ],
            1 =>
                [
                    'name'        => '$USER3$',
                    'value'       => 'B',
                    'description' => 'Windows WMI Plugin - Active Directory Password',
                    'password'    => '0',
                    'created'     => '2017-06-27 09:56:14',
                    'modified'    => '2017-07-21 15:06:32',
                ],
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getHosttemplatesData() {
        $data = [
            /*
            [
                'id'                                => '2',
                'uuid'                              => 'd2f712ef-fc7e-4004-9bdc-8c819f00fff',
                'name'                              => 'My Hosttemplate',
                'description'                       => '',
                'hosttemplatetype_id'               => '1',
                'command_id'                        => 'bc922eb4-84ad-44cc-9dff-43a464097753',
                ...
            ],
            [
                'id'                                => '3',
                'uuid'                              => '82e7245a-f1be-41cd-b074-ff88681f7fff',
                'name'                              => 'Another Hosttemplate',
                'description'                       => '',
                'hosttemplatetype_id'               => '1',
                'command_id'                        => 'bc922eb4-84ad-44cc-9dff-43a464097753',
                ...
            ]
            */
        ];
        return $data;
    }

    /**
     * @return array
     */
    public function getServicetemplatesData() {
        $data = [
            0 =>
                [
                    'uuid'                                      => 'b3e91516-5afa-4f1e-ada6-b092194850c2',
                    'template_name'                             => 'WINDOWS_WMI_CPU',
                    'name'                                      => 'WINDOWS_WMI_CPU',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for cpu utilisation',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => null,
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:29:54',
                    'modified'                                  => '2017-06-27 10:29:54',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkcpu',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-w 80 -w 90',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
            1 =>
                [
                    'uuid'                                      => '26c46ed4-5f0f-4427-9bfe-3389719c34cd',
                    'template_name'                             => 'WINDOWS_WMI_PROCESS',
                    'name'                                      => 'WINDOWS_WMI_PROCESS',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for process and services',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => '',
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:45:56',
                    'modified'                                  => '2017-06-27 10:50:00',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkprocess',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-a Processname -w 1:1 -c 1:1',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
            2 =>
                [
                    'uuid'                                      => 'e35a3206-ab56-4dbb-a17b-eb3f50f76288',
                    'template_name'                             => 'WINDOWS_WMI_IO',
                    'name'                                      => 'WINDOWS_WMI_IO',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for io',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => '',
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:51:27',
                    'modified'                                  => '2017-06-27 10:53:17',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkio',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-s logical -a C:',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
            3 =>
                [
                    'uuid'                                      => '8c6668b2-57d5-4979-af3a-2b4ed0a67bd8',
                    'template_name'                             => 'WINDOWS_WMI_FILESIZE',
                    'name'                                      => 'WINDOWS_WMI_FILESIZE',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for filesize',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => '',
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:54:14',
                    'modified'                                  => '2017-06-27 10:55:36',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkfilesize',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-a c:/pagefile.sys -w 1500m -c 2g',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
            4 =>
                [
                    'uuid'                                      => '3a019c90-8543-4695-af55-131fe2550816',
                    'template_name'                             => 'WINDOWS_WMI_DISK',
                    'name'                                      => 'WINDOWS_WMI_DISK',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for disk',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => '',
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:56:57',
                    'modified'                                  => '2017-06-27 10:57:59',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkdrivesize',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-a . -w 80 -c 90',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
            5 =>
                [
                    'uuid'                                      => 'a9a1a1c4-9996-4dc0-b55b-d15472327398',
                    'template_name'                             => 'WINDOWS_WMI_APPLICATION_LOG',
                    'name'                                      => 'WINDOWS_WMI_APPLICATION_LOG',
                    'container_id'                              => '1',
                    'servicetemplatetype_id'                    => '1',
                    'check_period_id'                           => '1',
                    'notify_period_id'                          => '1',
                    'description'                               => 'Window wmi check for application event log',
                    'command_id'                                => '53fe1133-03ab-40fa-a4a6-4ab99501fa08',
                    'check_command_args'                        => '',
                    'checkcommand_info'                         => '',
                    'eventhandler_command_id'                   => '0',
                    'timeperiod_id'                             => '0',
                    'check_interval'                            => '300',
                    'retry_interval'                            => '60',
                    'max_check_attempts'                        => '3',
                    'first_notification_delay'                  => '0',
                    'notification_interval'                     => '0',
                    'notify_on_warning'                         => '0',
                    'notify_on_unknown'                         => '0',
                    'notify_on_critical'                        => '1',
                    'notify_on_recovery'                        => '1',
                    'notify_on_flapping'                        => '0',
                    'notify_on_downtime'                        => '0',
                    'flap_detection_enabled'                    => '0',
                    'flap_detection_on_ok'                      => '0',
                    'flap_detection_on_warning'                 => '0',
                    'flap_detection_on_unknown'                 => '0',
                    'flap_detection_on_critical'                => '0',
                    'low_flap_threshold'                        => '0',
                    'high_flap_threshold'                       => '0',
                    'process_performance_data'                  => '1',
                    'freshness_checks_enabled'                  => '0',
                    'freshness_threshold'                       => null,
                    'passive_checks_enabled'                    => '0',
                    'event_handler_enabled'                     => '0',
                    'active_checks_enabled'                     => '1',
                    'retain_status_information'                 => '0',
                    'retain_nonstatus_information'              => '0',
                    'notifications_enabled'                     => '1',
                    'notes'                                     => '',
                    'priority'                                  => '1',
                    'tags'                                      => '',
                    'service_url'                               => '',
                    'is_volatile'                               => '0',
                    'check_freshness'                           => '0',
                    'created'                                   => '2017-06-27 10:58:37',
                    'modified'                                  => '2017-07-03 10:26:44',
                    'servicetemplateeventcommandargumentvalues' =>
                        [
                        ],
                    'servicetemplatecommandargumentvalues'      =>
                        [
                            0 =>
                                [
                                    'commandargument_id' => '$ARG1$',
                                    'value'              => 'checkeventlog',
                                ],
                            1 =>
                                [
                                    'commandargument_id' => '$ARG2$',
                                    'value'              => '-a application -o 2 -3 1 -w 50 -c 100',
                                ],
                        ],
                    'customvariables'                           =>
                        [
                        ],
                    'servicegroups'                             =>
                        [
                        ],
                    'contactgroups'                             =>
                        [
                        ],
                    'contacts'                                  =>
                        [
                        ],
                ],
        ];
        return $data;
    }

    public function getServicetemplategroupsData() {
        $data = [
            0 =>
                [
                    'uuid'             => '1945a1f2-1665-49cd-a255-7cc0505014dd',
                    'description'      => 'Window WMI Monitoring Basic',
                    'servicetemplates' =>
                        [
                            0 =>
                                [
                                    'id'   => 'a9a1a1c4-9996-4dc0-b55b-d15472327398',
                                    'uuid' => 'a9a1a1c4-9996-4dc0-b55b-d15472327398',
                                ],
                            1 =>
                                [
                                    'id'   => 'b3e91516-5afa-4f1e-ada6-b092194850c2',
                                    'uuid' => 'b3e91516-5afa-4f1e-ada6-b092194850c2',
                                ],
                            2 =>
                                [
                                    'id'   => '3a019c90-8543-4695-af55-131fe2550816',
                                    'uuid' => '3a019c90-8543-4695-af55-131fe2550816',
                                ],
                            3 =>
                                [
                                    'id'   => '8c6668b2-57d5-4979-af3a-2b4ed0a67bd8',
                                    'uuid' => '8c6668b2-57d5-4979-af3a-2b4ed0a67bd8',
                                ],
                            4 =>
                                [
                                    'id'   => 'e35a3206-ab56-4dbb-a17b-eb3f50f76288',
                                    'uuid' => 'e35a3206-ab56-4dbb-a17b-eb3f50f76288',
                                ],
                            5 =>
                                [
                                    'id'   => '26c46ed4-5f0f-4427-9bfe-3389719c34cd',
                                    'uuid' => '26c46ed4-5f0f-4427-9bfe-3389719c34cd',
                                ],
                        ],
                    'container'        =>
                        [
                            'name'             => 'Window WMI Monitoring Basic',
                            'parent_id'        => 1,
                            'containertype_id' => '9',
                        ],
                ],
        ];
        return $data;
    }
}
